﻿var ej = {
	flavor : []
};

function ejShowRes(res) {
	var html='', cl='', tmpTitle='', ok=true, tmpCss='';
	if (res<0) {
		cl = ' danger';
		tmpTitle = 'A negative value means that the current mix is not feasible.';
		tmpCss = ' style="cursor:help;"';
		ok=false;
	}
	if (ej.sh.ml) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res,2)+'</td>'; }
	if (ej.sh.cl) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/10,2)+'</td>'; }
	if (ej.sh.dl) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/100,2)+'</td>'; }
	if (ej.sh.l) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/1000,2)+'</td>'; }
	return { html: html, ok: ok };
}

function calculateJuice() {
	var ii;
	ej.nicBaseNonnicP = 100-ej.nicBaseNicP;
	ej.nicBaseRealVgP = ej.nicBaseVgP * (ej.nicBaseNonnicP/100);
	ej.nicBaseRealPgP = ej.nicBasePgP * (ej.nicBaseNonnicP/100);
	ej.nicTargetVol = ej.batch*ej.targetNicP/100;
	ej.nicBaseVol = ej.nicTargetVol/(ej.nicBaseNicP/100);
	ej.nicBaseNicVol = (ej.targetNicP/100)*ej.batch;
	ej.nicBasePgVol = ej.nicBaseVol * (ej.nicBaseRealPgP/100);
	ej.nicBaseVgVol = ej.nicBaseVol * (ej.nicBaseRealVgP/100);
	ej.targetPgVol = (ej.targetPgP/100)*(ej.batch-ej.nicBaseNicVol);
	ej.targetVgVol = (ej.targetVgP/100)*(ej.batch-ej.nicBaseNicVol);
	
	
	ej.addPgVol = ej.targetPgVol - ej.nicBasePgVol;
	ej.addVgVol = ej.targetVgVol - ej.nicBaseVgVol;


	if (ej.flavor) {
		for (ii = 0; ii < ej.flavor.length; ii++) {
			// ej.perc
			ej.flavor[ii].vol = ej.batch * (ej.flavor[ii].perc/100);
			if (ej.flavor[ii].vg) {
				ej.addVgVol -= ej.flavor[ii].vol;
			} else {
				ej.addPgVol -= ej.flavor[ii].vol;
			}
		}
	}


	var html;
	var tmp, tmpOk = true;
	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Ingredient</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine</td>';
			tmp = ejShowRes(round(ej.nicBaseNicVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(round(ej.nicBaseVgVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(round(ej.nicBasePgVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-breakdown').html(html);
	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Ingredient</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine</td>';
			tmp = ejShowRes(round(ej.nicBaseNicVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(ej.targetVgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(ej.targetPgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-ingredients').html(html);

	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Add</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine base';
			if (ej.nicBaseVgP === 100) {
				html += ' (VG)';
			} else if (ej.nicBasePgP === 100) {
				html += ' (PG)';
			} else {
				html += ' (PG/VG)';
			}
			html += '</td>';
			tmp = ejShowRes(ej.nicBaseVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		if (ej.flavor) {
			for (ii = 0; ii < ej.flavor.length; ii++) {
				html += '<tr>';
					html += '<td><i>' + ej.flavor[ii].nm + ' (';
					if (ej.flavor[ii].vg) {
						html += 'VG';
					} else {
						html += 'PG';
					}
					html += ')</i></td>';
					//html += '<td class="text-right">' + ej.flavor[ii].vol + '</td>';
					html += ejShowRes(ej.flavor[ii].vol).html;
				html += '</tr>';
			}
		}
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(ej.addVgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(ej.addPgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-results').html(html);
	activateBlinkies($('#ej-results'));
	var errorMsg = '';
	if (ej.nicBaseNicP<ej.targetNicP) {
		errorMsg += '<p>Oops. Your target nicotine level is higher than your nicotine base strength. You should either get a stronger nic base liquid, or lower your target nic strength.</p>';
		tmpOk = false;
	}
	//console.log(tmpOk);
	var $em = $('#ej-errormsg');
	if (!tmpOk) {
		errorMsg += '<p>';
			errorMsg += 'This mix is not feasible.';
			errorMsg += ' You may need to lower your target nic, VG or PG content, or flavoring.';
			errorMsg += ' Alternatively, use a stronger nic base liquid, or a nic base liquid with a different VG/PG ratio.';
			errorMsg += ' Please adjust your settings.';
		errorMsg += '</p>';
		$em.html('<div class="alert alert-danger blinky" data-blink="#ej-results td.danger">' + errorMsg + '</div>');
		if (!$em.is(':visible')) {
			$em.slideDown(200);
		}
	} else {
		if ($em.is(':visible')) {
			$em.slideUp(200);
		}
	}
	return;
}


function defaultJuice() {
	return {
		batch : 10
		,sh : { 
			ml: true
			,cl: false
			,dl: false
			,l: false
			}
		,batchUnit : 'ml'
		,nicUnit : 'p'
		,nicBaseNicP : 2.7
		,nicBasePgP : 100
		,nicBaseVgP : 0
		,targetNicP : 1.8
		,targetPgP : 70
		,targetVgP : 30
		,flavor: []
	};
}
function addFlavor(nm, perc, vg) {
	var x = '<tr>';
		x += '<td><input class="form-control input-sm flavor-nm" value="' + nm +'" /></td>';
		x += '<td><i class="glyphicon glyphicon-remove text-muted"></i></td>';
		x += '<td><input class="form-control input-sm text-right flavor-percent" type="number" value="'+perc+'" /></td>';
		x += '<td class="text-center"><input type="checkbox" class="flavor-vg"';
		if (vg) {
			x += ' checked="checked"';
		}
		x += ' /></td>';
	x += '</tr>';
	$('#ej-flavoring').append(x);
	return;
}

function writeFlavors() {
	var ii;
	var fl = ej.flavor;
	if (fl.length === 0) {
		addFlavor('Flavor', 0, false);
	} else {
		for (ii = 0; ii < fl.length; ii++) {
			addFlavor(fl[ii].nm, fl[ii].perc, fl[ii].vg);
		}
	}
	return;
}
function writeJuice() {
	$('#ej-batch').val(ej.batch);
	$('#ej-nicbasepgp').val(ej.nicBasePgP);
	$('#ej-nicbasevgp').val(ej.nicBaseVgP);
	$('#ej-targetpgp').val(ej.targetPgP);
	$('#ej-targetvgp').val(ej.targetVgP);
	$('#ej-batch-u').find('input').prop('checked',false);
	var tmp = '#ej-batch-u-' + ej.batchUnit;
	$(tmp).prop('checked',true);
	if (ej.nicUnit==='m') {
		$('#ej-nic-unit-disclaimer').show('slideDown');
		$('#ej-nic-unit-p').prop('checked',false);
		$('#ej-nic-unit-mgml').prop('checked',true);
		$('.ej-nic-unit span').html('<sup>mg</sup>/<sub>ml</sub>');
		$('#ej-nicbasenicp').val(ej.nicBaseNicP*10);
		$('#ej-targetnicp').val(ej.targetNicP*10);
	} else {
		$('#ej-nic-unit-disclaimer').hide();
		$('#ej-nic-unit-mgml').prop('checked',false);
		$('#ej-nic-unit-p').prop('checked',true);
		$('.ej-nic-unit span').html('%');
		$('#ej-nicbasenicp').val(ej.nicBaseNicP);
		$('#ej-targetnicp').val(ej.targetNicP);
	}
	return;
}
function getFlavors() {
	ej.flavor = [];
	$('#ej-flavoring tr').each(function() {
		ej.flavor.push({
			nm : $(this).find('.flavor-nm').val()
			,perc : parseFloat($(this).find('.flavor-percent').val())
			,vg : $(this).find('.flavor-vg').is(':checked')
		});
	});
	return;
}


function startJuice() {
	var tmp = seLoad('ej');
	if (tmp) {
		ej = tmp;
		writeFlavors();
		writeJuice();
	} else {
		ej = defaultJuice();
		writeJuice();
		$('#ej-load').hide();
	}
	$('#ej-batch').change(function() {
		ej.batch = parseFloat($(this).val());
		calculateJuice();
		gad('juice', 'batch', ej.batch);
	});
	$('#ej-batch-unit').find('input').change(function() {
		ej.batchUnit = $(this).val();
		$('#ej-batch-addon span').html(ej.batchUnit);
		calculateJuice();
		gad('juice', 'batchunit', ej.batchUnit);
	});
	$('#ej-nic-unit').find('input').change(function() {
		if ($('#ej-nic-unit-p').is(':checked')) {
			ej.nicUnit = 'p';
			//$('#ej-nicbasenicp').val($('#ej-nicbasenicp').val()/10).attr('step','0.1').attr('max','50');
			//$('#ej-targetnicp').val($('#ej-targetnicp').val()/10).attr('step','0.1').attr('max','10');
			//ej.nicP
		} else {
			ej.nicUnit = 'm';
			//$('#ej-nicbasenicp').val($('#ej-nicbasenicp').val()*10).attr('step','1').attr('max','500');
			//$('#ej-targetnicp').val($('#ej-targetnicp').val()*10).attr('step','1').attr('max','100');
		}
		writeJuice();
		ej.nicBaseNicP = parseFloat($('#ej-nicbasenicp').val());
		if (ej.nicUnit === 'm') {
			ej.nicBaseNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'nicunit', ej.nicUnit);
	});
	$('#ej-nicbasenicp').change(function() {
		ej.nicBaseNicP = parseFloat($(this).val());
		if (ej.nicUnit === 'm') {
			ej.nicBaseNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'nicbasenicp', ej.nicBaseNicP);
	});
	$('#ej-nicbasepgp').change(function() {
		ej.nicBasePgP = parseFloat($(this).val());
		ej.nicBaseVgP = 100 - ej.nicBasePgP;
		$('#ej-nicbasevgp').val(ej.nicBaseVgP);
		calculateJuice();
		gad('juice', 'nicbasepgp', ej.nicBasePgP);
	});
	$('#ej-nicbasevgp').change(function() {
		ej.nicBaseVgP = parseFloat($(this).val());
		ej.nicBasePgP = 100 - ej.nicBaseVgP;
		$('#ej-nicbasepgp').val(ej.nicBasePgP);
		calculateJuice();
		gad('juice', 'nicbasevgp', ej.nicBaseVgP);
	});
	$('#ej-targetnicp').change(function() {
		ej.targetNicP = parseFloat($(this).val());
		if (ej.nicUnit === 'm') {
			ej.targetNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'targetnicp', ej.targetNicP);
	});
	$('#ej-targetpgp').change(function() {
		ej.targetPgP = parseFloat($(this).val());
		ej.targetVgP = 100 - ej.targetPgP;
		$('#ej-targetvgp').val(ej.targetVgP);
		gad('juice', 'targptpgp', ej.targetPgP);
		calculateJuice();
	});
	$('#ej-targetvgp').change(function() {
		ej.targetVgP = parseFloat($(this).val());
		ej.targetPgP = 100 - ej.targetVgP;
		$('#ej-targetpgp').val(ej.targetPgP);
		gad('juice', 'targetvgp', ej.targetVgP);
		calculateJuice();
	});
	$('#ej-save').click(function() {
		seSave('ej',ej);
		$('#ej-load').show();
		gad('juice', 'save');
	});
	$('#ej-load').click(function() {
		tmp = seLoad('ej');
		ej = tmp;
		$('#ej-flavoring').html('');
		writeFlavors();
		writeJuice();
		calculateJuice();
		gad('juice', 'load');
	});
	$('#ej-reset').click(function() {
		ej = defaultJuice();
		$('#ej-flavoring').html('');
		writeJuice();
		calculateJuice();
		ccMenuMsg('Default settings have been restored.','success');
		gad('juice', 'reset');
	});
	$('#ej-addflavor').click(function() {
		gad('juice', 'flavor', 'add');
		addFlavor('Flavor ' + (ej.flavor.length+1), 0, false);
		getFlavors();
		calculateJuice();
	});
	$('#ej-flavoring').on('change', 'input', function() {
		gad('juice', 'flavor', 'change');
		getFlavors();
		calculateJuice();
	});
	$('#ej-flavoring').on('click', '.glyphicon-remove', function() {
		gad('juice', 'flavor', 'remove');
		$(this).parents('tr').remove();
		getFlavors();
		calculateJuice();
	});
	if (ej.flavor.length > 0) {
		setTimeout(function() {
			$('#ej-flavoring-collapse').collapse('show');
			gad('juice', 'flavor', 'loadwithflavor');
		},500);
	}
	calculateJuice();
	return;
}

$(document).ready(function() {
	//$.getJSON('http://freegeoip.net/json/', function(location) {
		//choo.country = location.country_code;
		startJuice();
	//});
});