﻿var choo = {
	timeouts : {}
};
function gad(a, b, c) { // ga delayed
	clearTimeout(choo.timeouts[a+'-'+b]);
	choo.timeouts[a+'-'+b] = setTimeout(function() {
		ga('send', 'event', a, b, c);
		//console.log('sender event ['+a+']['+b+']['+c+']');
	},2000);
	return;
}

function createCookie(name, value, days) {
    var expires, date;
    if (days) {
        date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    } else {
        expires = "";
    }
    document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
	return;
}

function readCookie(name) {
    var nameEQ = encodeURIComponent(name) + "=";
    var ca = document.cookie.split(';');
	var i, c;
    for (i = 0; i < ca.length; i++) {
        c = ca[i];
        while (c.charAt(0) === ' ') { c = c.substring(1, c.length); }
        if (c.indexOf(nameEQ) === 0) { return decodeURIComponent(c.substring(nameEQ.length, c.length)); }
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name, "", -1);
	return;
}

function round(number, decimals) {
	if (decimals===undefined) { decimals=2; }
	var tmpFactor = Math.pow(10,decimals);
	return Math.round(number*tmpFactor)/tmpFactor;
}

function makeid() {
    var text = "",ii;
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for (ii=0; ii < 8; ii++ ) {
        text += possible.charAt(Math.floor(Math.random() * possible.length));
	}
    return text;
}

function slideUp($what) {
	$what.slideUp(200, function() {
		$what.remove();
	});
	return;
}

function fadeOut($what,interv) {
	setTimeout(function() {
		slideUp($what);
	},interv);
	return;
}

function ccMenuMsg(msg,msgtype,timeout) {
	if (timeout===undefined) {
		if (msgtype === 'danger') {
			timeout = 7500;
		} else {
			timeout = 3500;
		}
	}
	var html = '';
	var id = 'menumsg-'+makeid();
	html += '<div class="alert alert-'+msgtype+' fade5" id="'+id+'" >';
		html += '<a class="close">&times;</a>';
		html += msg;
	html += '</div>';
	$('.menumsg-inner').append(html);
	if (msgtype==='danger') {
		$('.menumsg-inner').css({ opacity: 0.9 });
	} else {
		$('.menumsg-inner').css({ opacity: 0.9 });
	}
	if (timeout > 0) {
		fadeOut($('#'+id),timeout);
	}
	$('#'+id).click(function() {
		slideUp($('#'+id));
	});
	return;
}

function seSave(nm, settings) {
	createCookie('steamengine-'+nm, JSON.stringify(settings), 9999);
	ccMenuMsg('Settings have been saved.','success');
	return;
}
function seLoad(nm) {
	var tmp = readCookie('steamengine-'+nm);
	//console.log('seload');
	//console.log(tmp);
	if (tmp) {
		//console.log($.parseJSON(tmp));
		if (nm!=='theme') {
			ccMenuMsg('Settings have been loaded.','success');
		}
		return $.parseJSON(tmp);
	}
	return;
}

function setCss() {
	var $css = $('link#bscss');
	if ($css.attr('data-origcss')===undefined) {
		$css.attr('data-origcss',$css.attr('href'));
	}
	if (choo.bsnm===undefined) {
		choo.bsnm = 'default';
	}
	if (choo.bsnm==='default') {
		$css.attr('href',$css.attr('data-origcss'));
	} else {
		$css.attr('href',choo.bscss);
	}
	$('#theme').find('.bootswatch[data-nm="'+choo.bsnm+'"]').addClass('bg-success');
	return;
}

function themeLoad() {
	var settings = seLoad('theme');
	if (settings) {
		choo.bscss = settings.bscss;
		choo.bsnm = settings.bsnm;
	} else {
		choo.bscss = '';
		choo.bsnm = 'default';
	}
	setCss();
	return;
}

function activateBlinky($el) {
	var $target = $($el.attr('data-blink'));
	var binterval;
	$el.css('cursor','help').mouseenter(function() {
		binterval = setInterval(function() {
			$target.fadeTo(180, 0.2).fadeTo(360, 1.0);
		},900);
		$target.fadeTo(80, 0.2).fadeTo(240, 1.0);
	}).mouseleave(function() {
		clearInterval(binterval);
	});
	return false;
}
function activateBlinkies($el) {
	$el.find('.blinky').each(function() {
		activateBlinky($(this));
		//$(this).addClass('bg-success');
		//$(this).css('font-weight','bolder');
	});
	return false;
}

function bool2int(b) {
	if (b) {
		return 1;
	}
	return 0;
}

function fixQr() {
	var src;
	$('.qrkode').each(function() {
		var $qr = $(this);
		var size = $qr.attr('data-size');
		src = 'http://' + 'chart.apis.google.com/chart?cht=qr&chs='+size+'x'+size+'&chl=http://' + 'www.steam-engine.org';
		$qr.attr('src',src);
	});
	$('.qrkode').click(function() {
		$('.qrkode').toggle();
	});
	return;
}


function observeInputs() {
	$('input').each(function() {
		var $inp = $(this);
		$inp.focus(function() {
			choo.inpVal = $(this).val();
		}).blur(function() {
			clearTimeout(choo.inpTimeout);
		}).keyup(function() {
			clearTimeout(choo.inpTimeout);
			choo.inpTimeout = setTimeout(function() {
				if (choo.inpVal !== $inp.val() && $inp.val() !== '') {
					choo.inpVal = $inp.val();
					$inp.change();
					$inp.css('background-color','#bfffbf');
					setTimeout(function() {
						$inp.css('background-color','');
					},250);
				}
			},2500);
		});
	});
	return;
}
function startSteamEngine() {
	themeLoad();
	fixQr();
	activateBlinkies($('body'));
	$('.link-ecf-imac').each(function() {
		$(this).attr('href','http://www.e-cigarette-forum.com/forum/blogs/dampmaskin/5833-steam-engine-vape-calc.html').attr('target','_blank').attr('title','e-cigarette-forum blog post').html('e-cigarette-forum');
	});
	$('a.wplink').each(function() {
		$(this).attr('target','_blank');
		var t = $(this).attr('title');
		if (t===undefined) {
			//t = 'Read about it';
			t = $(this).html();
		}
		$(this).attr('title', 'Wikipedia: ' + t + ' (opens in a new tab)');
		$(this).attr('rel','nofollow');
	});
	observeInputs();
	return;
}

function right(str, n){
	if (n <= 0) { return ''; }
	if (n > String(str).length) { return str; }
	var iLen = String(str).length;
	return String(str).substring(iLen, iLen - n);
}

function setHelpClass($el) {
	$el.find('*').each(function() {
		//console.log(this.tagName);
		if (this.tagName!=='A') {
			var titl = $(this).attr('title');
			if (titl!==undefined && titl!=='') {
				//$(this).css('cursor','help');
				$(this).addClass('helpcursor');
			}
		}
	});
	return;
}
function getQueryStrings() {
	var assoc = {};
	var decode = function (s) { return decodeURIComponent(s.replace(/\+/g, " ")); };
	var queryString = location.search.substring(1); 
	var keyValues = queryString.split('&'); 
	var ii, key;
	for (ii in keyValues) { 
		if (keyValues.hasOwnProperty(ii)) {
			key = keyValues[ii].split('=');
			if (key.length > 1) {
				if (key[0] === 'ref') {
					//console.log('er ref');
				} else {
					assoc[decode(key[0])] = decode(key[1]);
				}
			}
		}
	} 
	return assoc; 
}

function updateQs(url) {
	url = url.replace('&','?');
	if (url==='') {
		history.replaceState('','','?');
	} else {
		history.replaceState('','',url);
	}
	return;
}

function feedbackModal(header, helptxt, msgtxt) {
	$('#semodal').find('h4').html(header);
	var html = '';
	html += '<span class="help-block">'+helptxt+'</span>';
	html += '<label>Your message</label>';
	html += '<textarea class="form-control">';
		html += msgtxt;
	html += '</textarea>';
	html += '<span class="help-block">If you would like a reply, remember to include your email address as well.</span>';
	$('#semodal').find('.modal-body').html(html);
	$('#semodal').find('.modal-footer').html('<button class="btn btn-primary sendbtn disabled">Send</button>');
	$('#semodal').modal('show');
	$('#semodal').find('textarea').keyup(function() {
		$('#semodal').find('.sendbtn').removeClass('disabled');
	});
	$('#semodal').find('.sendbtn').click(function() {
		$('#semodal').find('.modal-footer').html('<p>One moment please ...</p>');
		$.post('feedback.asp?a=feedback', {
			txt : $('#semodal').find('textarea').val()
		}, function(resultat) {
			var res = $.parseJSON(resultat);
			if (res.ok) {
				$('#semodal').find('.modal-body').html('Message is sent. Thank you!');
			} else {
				$('#semodal').find('.modal-body').append('<div class="alert alert-error">Sorry, an error has occured. Error code <code>'+res.err+'</code>. Error message: <pre>'+res.err2+'</pre></div>');
			}
			$('#semodal').find('.modal-footer').html('');
		});
	});
	return;
}

function readNumber(n) {
	return parseFloat(n.replace(',','.'));
}

$(document).ready(function() {
	//console.log(window.location.href.replace('alhost','ALHOST'));
	if (window.location.href.substr(0,23)==='http://steam-engine.org') {
		//window.location.href = 'http://www.steam-engine.org';
		window.location.href = window.location.href.replace('//steam-engine.org','//www.steam-engine.org');
	}
	if (right(location.href,10)==='#coilpower') { window.location.href = 'ohm.asp'; }
	if (right(location.href,15)==='#coildimensions') { window.location.href = 'coil.asp'; }
	if (right(location.href,10)==='#battdrain') { window.location.href = 'batt.asp'; }
	if (right(location.href,7)==='#ejuice') { window.location.href = 'juice.asp'; }
	var sideid = $('body').attr('id');
	$('#choo-topnav').find('#navtab-' + sideid).addClass('active');
	$('.menumsg').html('<div class="menumsg-inner"></div>');
	startSteamEngine();
	setHelpClass($('body'));
	$('#howdoesitwork').click(function() {
		$(this).toggleClass('active');
		$('.howdoesitwork').toggle('fold');
	});
	$('.howdoesitwork').hide();
	$('.feedback').click(function() {
		var title = $(this).attr('data-title');
		var heading = $(this).attr('data-heading');
		var text = $(this).attr('data-text');
		if (title === undefined) { title = 'Feedback about the Steam Engine'; }
		if (heading === undefined) { heading = 'Please write your message here.'; }
		if (text === undefined) { text = ''; }
		feedbackModal(title, heading, text);
	});
	// Reklame-fallback
	if ($('body').attr('data-am') !== 'appfull') {
		if ($('.ecmfallback').length === 0) {
			// ingen ecm-banner med fallback, da kan vi vise adsense med en gang.
			(adsbygoogle = window.adsbygoogle || []).push({});
		} else {
			// gi ecm halvannet sekund på å laste, og sjekk deretter om den har lastet
			setTimeout(function() {
				if ($('.ecmfallback img').length === 0) {
					// ecm klarte ikke å laste banner. fallback til adsense.
					(adsbygoogle = window.adsbygoogle || []).push({});
				}
			},1500);
		}
		// Reklame-statistikk
		setTimeout(function() {
			var ecmshow = $('.ecmfallback img').length + $('.ecmbanner img').length;
			var abgshow = 0;
			$('.adsbygoogle').each(function() {
				if ($(this).height() > 0) {
					abgshow++;
				}
			});
			var ecmpot = $('.ecmfallback').length + $('.ecmbanner').length;
			var abgpot = $('.adsbygoogle').length;
			var handl, detalj = '';
			if (ecmshow > 0 && abgshow > 0) {
				handl = 'ecm+abg';
			} else if (ecmshow > 0) {
				handl = 'ecm';
			} else if (abgshow > 0) {
				handl = 'abg';
			} else {
				handl = 'ingen';
				choo.adblokket = true;
			}
			detalj = 'ecmshow: ' + ecmshow + '/'+ecmpot+', abgshow: ' + abgshow + '/' + abgpot;
			//console.log(handl,detalj);
			gad('adshow', handl, detalj);
			
		},3000);
	}
	// eksterne lenker
	$('a[target="_blank"]').click(function() {
		gad('eksternlink', $(this).text(), $(this).attr('href'));
	});
});